﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using CEIP = ComiLib.cEIP.SafeNativeMethods;

namespace cEIP_Digital_Output
{
    public partial class cEIP_Digital_Output : Form
    {
        const int nRealNode = 10; // 이 값은 실제 노드(ceNM-SE) 개수를 입력하면 됩니다.
        const int nTimeOut = (10 * 100); // 노드 하나당 100ms
        int nInitCh = 0;
        const int nNumCh = 32;
        //bool bIsDeviceAvailable = false;
        int nIsSearchedDev = 0;
        int nNumNodes = 0;
        //int nNumDioNodes = 0;
        int nNodeID = 100; //Master Module ID
        uint nDOState = 0;
        int nRtn = 0;
        Button[] DoState;
        bool bIsLogicMode = false;
        int nLogicMask = 0;

        public cEIP_Digital_Output()
        {
            InitializeComponent();

            DoState = new Button[nNumCh]
            {
                btnDO0, btnDO1,btnDO2,btnDO3,btnDO4,btnDO5,btnDO6,btnDO7,btnDO8,btnDO9,btnDO10,
                btnDO11,btnDO12,btnDO13,btnDO14,btnDO15,btnDO16,btnDO17,btnDO18,btnDO19,btnDO20,
                btnDO21,btnDO22,btnDO23,btnDO24,btnDO25,btnDO26,btnDO27,btnDO28,btnDO29,btnDO30,
                btnDO31,
            };
        }

        private void cEIP_DO_Load(object sender, EventArgs e)
        {
            nRtn = CEIP.ceGnLoad(); //
            if (nRtn != CEIP.ceERR_NONE) // 라이브러리가 로드 된 상태에서 라이브러리 사용을 위한 구동 초기화 역할을 합니다
                GetLog("Library Initialize Failed, follow the ErrorCode");
            else
            {
                GetLog("Library Initialize Success");
            }
        }

        private void btnNodeScan_Click(object sender, EventArgs e)
        {
            nInitCh = Convert.ToInt32(textBox_InitCh.Text);

            NodeScan();
            FindDioNodes();

            timer_DOCheck.Enabled = true;
        }

        internal void NodeScan()
        {
            nRtn = CEIP.ceGnIsSearchedDevice(ref nIsSearchedDev); // 노드 탐색 완료 여부 확인, 노드 탐색 전이라면 ceGnSearchDevice, 노드 탐색 후라면 ceGnReSearchEdvice 사용
            if (nIsSearchedDev == 0) // 노드 검색이 기존에 완료되지 않음
            {
                if ((nRtn = CEIP.ceGnSearchDevice(nRealNode, nTimeOut, 0, ref nNumNodes)) < 0)
                    GetLog("Can Not Find Any Nodes");
                else
                    GetLog(nNumNodes.ToString() + " Node(s) Master Fined");
            }
            else
            {
                if ((nRtn = CEIP.ceGnReSearchDevice(nRealNode, nTimeOut, 0, ref nNumNodes)) < 0)
                    GetLog("Can Not Find Any Nodes");
                else
                    GetLog(nNumNodes.ToString() + " Node(s) Master Fined");
            }
        }

        internal void FindDioNodes()
        {
            int nDIOModuleCnt = 0;
            int nNumDIOCh = 0;

            nRtn = CEIP.ceGnTotalDIOChannel(ref nNumDIOCh);
            if (nRtn == 0)
                GetLog("DIO Channel Count : " + nNumDIOCh.ToString());
            else
                GetLog("ceGnTotalDIOChannel Failed");
        }

        private void timer_DOCheck_Tick(object sender, EventArgs e)
        {
            if (bIsLogicMode == false)
            {
                nRtn = CEIP.cedioMulti_Get(nInitCh, nNumCh, ref nDOState);
                for (int i = 0; i < nNumCh ; i++)
                {
                    if (((nDOState >> i) & 0x1) == 1) // ON
                    {
                        DoState[i].BackColor = Color.DarkCyan;
                        DoState[i].Text = (i + nInitCh).ToString();
                    }
                    else
                    {
                        DoState[i].BackColor = Color.Transparent;
                        
                        DoState[i].Text = (i + nInitCh).ToString();
                    }
                }
            }
            else
            {
                nRtn = CEIP.cedioLogicMulti_Get(nInitCh, nNumCh, ref nLogicMask);
                for (int i = 0; i < nNumCh ; i++)
                {
                    if (((nLogicMask >> i) & 0x1) == (int)CEIP.SigLogic.LOGIC_A) 
                    {
                        DoState[i].BackColor = Color.DarkCyan;
                        DoState[i].Text = (i + nInitCh).ToString() + " A";
                    }
                    else
                    {
                        DoState[i].BackColor = Color.Transparent;
                        DoState[i].Text = (i + nInitCh).ToString() + " B";
                    }
                }
            }
        }

        internal void btnDO_Clicked(object sender, EventArgs e)
        {
            int nDOCh = Convert.ToInt16(((Button)sender).Tag) + nInitCh;

            if (bIsLogicMode == false)
                if (((nDOState >> nDOCh - nInitCh) & 0x1) == 0)
                {
                    nRtn = CEIP.cedioOne_Put(nDOCh, 1); //ON
                    GetLog("Ch " + nDOCh.ToString() + " ON");
                }
                else
                {
                    nRtn = CEIP.cedioOne_Put(nDOCh, 0); // OFF
                    GetLog("Ch " + nDOCh.ToString() + " OFF");
                }
            else
            {
                int nSelCh = Convert.ToInt16(((Button)sender).Tag) + nInitCh;
                int nSelChLogic = (((nLogicMask >> (nSelCh - nInitCh)) & 0x1) == (int)CEIP.SigLogic.LOGIC_A ? (int)CEIP.SigLogic.LOGIC_B : (int)CEIP.SigLogic.LOGIC_A);
                nRtn = CEIP.cedioLogicOne_Set(nSelCh, nSelChLogic);
                if (nRtn != CEIP.ceERR_NONE)
                    GetLog("Ch " + nSelCh.ToString() + " Logic Change Failed : " + nRtn.ToString());
                else
                    GetLog("Ch " + nSelCh.ToString() + " Logic Changed");
            }
        }

        private void btnModeChange_Click(object sender, EventArgs e)
        {
            bIsLogicMode = !bIsLogicMode;
            btnModeChange.Text = bIsLogicMode == true ? "Logic State" : "DO State";
        }

        private void cEIP_DO_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer_DOCheck.Enabled = false;
            nRtn = CEIP.ceGnUnload();
            Dispose();
        }

        internal void GetLog(string sLog)
        {
            lbLogView.Items.Add(sLog);
            lbLogView.SelectedIndex = lbLogView.Items.Count - 1;
        }

    }
}
